"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Tile.ts
var Tile_exports = {};
__export(Tile_exports, {
  default: () => Tile
});
module.exports = __toCommonJS(Tile_exports);
var import_Tile = __toESM(require("@boxslider/slider/effects/Tile"), 1);

// src/core.ts
var SafeBaseElement = typeof HTMLElement !== "undefined" ? HTMLElement : class {
};
var register = typeof customElements !== "undefined" ? (name, Element) => {
  if (customElements.get(name) === void 0) {
    customElements.define(name, Element);
  }
} : () => {
};

// src/Slider.ts
var import_BoxSlider = __toESM(require("@boxslider/slider/BoxSlider"), 1);
var BOOLEAN_ATTRIBUTES = ["auto-scroll", "loop", "pause-on-hover", "swipe"];
var NUMERIC_ATTRIBUTES = [
  "speed",
  "start-index",
  "swipe-tolerance",
  "timeout"
];
var SLIDER_ATTRIBUTES = [...BOOLEAN_ATTRIBUTES, ...NUMERIC_ATTRIBUTES];
var Slider = class extends SafeBaseElement {
  #slider;
  #observer;
  #optionsCache = {};
  static observedAttributes = SLIDER_ATTRIBUTES;
  #getOrDefault(option) {
    return this.#optionsCache[option] ?? this.#slider?.getOption(option) ?? import_BoxSlider.defaultOptions[option];
  }
  get slider() {
    return this.#slider;
  }
  get autoScroll() {
    return this.#getOrDefault("autoScroll");
  }
  set autoScroll(autoScroll) {
    if (this.slider) {
      if (autoScroll) {
        this.slider.play();
      } else {
        this.slider.pause();
      }
    } else {
      this.reset({ autoScroll });
    }
  }
  get loop() {
    return this.#getOrDefault("loop");
  }
  set loop(loop) {
    this.reset({ loop });
  }
  get pauseOnHover() {
    return this.#getOrDefault("pauseOnHover");
  }
  set pauseOnHover(pauseOnHover) {
    this.reset({ pauseOnHover });
  }
  get speed() {
    return this.#getOrDefault("speed");
  }
  set speed(speed) {
    this.reset({ speed });
  }
  get startIndex() {
    return this.#getOrDefault("startIndex");
  }
  set startIndex(startIndex) {
    this.reset({ startIndex });
  }
  get swipe() {
    return this.#getOrDefault("swipe");
  }
  set swipe(swipe) {
    this.reset({ swipe });
  }
  get swipeTolerance() {
    return this.#getOrDefault("swipeTolerance");
  }
  set swipeTolerance(swipeTolerance) {
    this.reset({ swipeTolerance });
  }
  get timeout() {
    return this.#getOrDefault("timeout");
  }
  set timeout(timeout) {
    this.reset({ timeout });
  }
  get options() {
    return {
      autoScroll: this.autoScroll,
      loop: this.loop,
      pauseOnHover: this.pauseOnHover,
      speed: this.speed,
      startIndex: this.startIndex,
      swipe: this.swipe,
      swipeTolerance: this.swipeTolerance,
      timeout: this.timeout
    };
  }
  constructor() {
    super();
    this.#observer = new MutationObserver((mutations) => {
      const needsReset = mutations.some(
        (mutation) => [...mutation.addedNodes, ...mutation.removedNodes].some(
          (node) => {
            return !(node instanceof HTMLElement && node.dataset.bsElement);
          }
        )
      );
      if (needsReset) {
        this.reset({ startIndex: this.slider?.activeIndex ?? 0 });
      }
    });
  }
  init(effect) {
    const slider = new import_BoxSlider.default(this, effect, this.#optionsCache);
    const events = [
      "after",
      "before",
      "destroy",
      "pause",
      "play",
      "reset"
    ];
    events.forEach(
      (ev) => slider.addEventListener(
        ev,
        (detail) => this.dispatchEvent(new CustomEvent(ev, { detail }))
      )
    );
    this.#slider = slider;
    this.#observer.observe(this, { childList: true });
    this.#optionsCache = {};
  }
  reset(options, effect) {
    if (this.slider) {
      const combinedOptions = { ...this.#optionsCache, ...options };
      this.slider?.reset(combinedOptions, effect);
      this.#optionsCache = {};
    } else {
      this.#optionsCache = { ...this.#optionsCache, ...options };
    }
  }
  attributeChangedCallback(name, _, value) {
    if (SLIDER_ATTRIBUTES.includes(name)) {
      const propName = name.replace(/-./g, (m) => m[1].toUpperCase());
      if (NUMERIC_ATTRIBUTES.includes(name)) {
        this[propName] = parseInt(value, 10);
      } else if (BOOLEAN_ATTRIBUTES.includes(name)) {
        this[propName] = value !== "false";
      }
    }
  }
  disconnectedCallback() {
    this.#observer.disconnect();
    this.slider?.destroy();
    this.#slider = void 0;
  }
};

// src/Tile.ts
var Tile = class extends Slider {
  static observedAttributes = [
    ...SLIDER_ATTRIBUTES,
    "rows",
    "row-offset",
    "tile-effect"
  ];
  #rows = 8;
  #rowOffset = 50;
  #tileEffect = "flip";
  get rows() {
    return this.#rows;
  }
  set rows(rows) {
    this.#rows = rows;
    this.reset(
      {},
      new import_Tile.default({
        rowOffset: this.rowOffset,
        rows,
        tileEffect: this.tileEffect
      })
    );
  }
  get rowOffset() {
    return this.#rowOffset;
  }
  set rowOffset(rowOffset) {
    this.#rowOffset = rowOffset;
    this.reset(
      {},
      new import_Tile.default({
        rowOffset,
        rows: this.rows,
        tileEffect: this.tileEffect
      })
    );
  }
  get tileEffect() {
    return this.#tileEffect;
  }
  set tileEffect(tileEffect) {
    this.#tileEffect = tileEffect;
    this.reset(
      {},
      new import_Tile.default({
        rowOffset: this.rowOffset,
        rows: this.rows,
        tileEffect
      })
    );
  }
  attributeChangedCallback(name, _, value) {
    if (name === "rows") {
      this.rows = parseInt(value, 10);
    } else if (name === "row-offset") {
      this.rowOffset = parseInt(value, 10);
    } else if (name === "tile-effect") {
      this.tileEffect = value;
    } else {
      super.attributeChangedCallback(name, _, value);
    }
  }
  connectedCallback() {
    this.init(
      new import_Tile.default({
        rows: this.rows,
        rowOffset: this.rowOffset,
        tileEffect: this.tileEffect
      })
    );
  }
};
register("bs-tile", Tile);
