import BoxSlider from '@boxslider/slider/BoxSlider';
import type { BoxSliderOptions, Effect } from '@boxslider/slider';
import { SafeBaseElement } from './core';
export declare const SLIDER_ATTRIBUTES: string[];
export interface SliderElementProps {
    autoScroll: boolean;
    pauseOnHover: boolean;
    speed: number;
    swipe: boolean;
    swipeTolerance: number;
    startIndex: number;
    timeout: number;
}
export interface SliderElement extends SliderElementProps, HTMLElement {
    readonly slider?: BoxSlider;
    readonly options: BoxSliderOptions;
}
export default abstract class Slider extends SafeBaseElement implements SliderElementProps {
    #private;
    static observedAttributes: string[];
    get slider(): BoxSlider | undefined;
    get autoScroll(): boolean;
    set autoScroll(autoScroll: boolean);
    get loop(): boolean;
    set loop(loop: boolean);
    get pauseOnHover(): boolean;
    set pauseOnHover(pauseOnHover: boolean);
    get speed(): number;
    set speed(speed: number);
    get startIndex(): number;
    set startIndex(startIndex: number);
    get swipe(): boolean;
    set swipe(swipe: boolean);
    get swipeTolerance(): number;
    set swipeTolerance(swipeTolerance: number);
    get timeout(): number;
    set timeout(timeout: number);
    get options(): BoxSliderOptions;
    constructor();
    protected init(effect: Effect): void;
    protected reset(options: Partial<BoxSliderOptions>, effect?: Effect): void;
    attributeChangedCallback(name: string, _: string, value: string): void;
    disconnectedCallback(): void;
}
